'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _os = require('os');

var _os2 = _interopRequireDefault(_os);

var _findCacheDir = require('find-cache-dir');

var _findCacheDir2 = _interopRequireDefault(_findCacheDir);

var _workerFarm = require('worker-farm');

var _workerFarm2 = _interopRequireDefault(_workerFarm);

var _cache = require('./cache');

var _serialization = require('./serialization');

var _versions = require('./versions');

var _versions2 = _interopRequireDefault(_versions);

var _worker2 = require('./worker');

var _worker3 = _interopRequireDefault(_worker2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var workerFile = require.resolve('./worker');

try {
  // run test
  workerFile = require.resolve('../../dist/uglify/worker');
} catch (e) {} // eslint-disable-line no-empty

var Uglify = function () {
  function Uglify(_ref) {
    var _ref$cache = _ref.cache,
        cache = _ref$cache === undefined ? (0, _findCacheDir2.default)({ name: 'uglifyjs-webpack-plugin' }) : _ref$cache,
        _ref$workers = _ref.workers,
        workers = _ref$workers === undefined ? _os2.default.cpus().length - 1 : _ref$workers;

    _classCallCheck(this, Uglify);

    this.cache = cache;
    this.workers = workers;
  }

  _createClass(Uglify, [{
    key: 'worker',
    value: function worker(options, callback) {
      if (this.workers > 0) {
        this.workerFarm = (0, _workerFarm2.default)({
          maxConcurrentWorkers: this.workers
        }, workerFile);
        this.worker = this.workerFarm;
      } else {
        this.worker = _worker3.default;
      }

      this.worker(options, callback);
    }
  }, {
    key: 'exit',
    value: function exit() {
      if (this.workerFarm) {
        _workerFarm2.default.end(this.workerFarm);
      }
    }
  }, {
    key: 'runTasks',
    value: function runTasks(tasks, callback) {
      var _this = this;

      var toRun = tasks.length;
      var results = [];
      var step = function step(index, data) {
        toRun -= 1;
        results[index] = data;
        if (!toRun) {
          callback(null, results);
        }
      };
      if (!tasks.length) {
        process.nextTick(function () {
          callback(null, results);
        });
        return;
      }
      tasks.forEach(function (task, index) {
        var json = (0, _serialization.encode)(task);
        var id = task.id || task.file;
        var cacheIdentifier = `${_versions2.default.uglify}|${_versions2.default.plugin}|${task.input}`;
        var enqueue = function enqueue() {
          _this.worker(json, function (errors, data) {
            var done = function done() {
              return step(index, errors ? { error: errors.message } : data);
            };
            if (_this.cache && !errors) {
              (0, _cache.put)(_this.cache, id, data, cacheIdentifier).then(done).catch(done);
            } else {
              done();
            }
          });
        };
        if (_this.cache) {
          (0, _cache.get)(_this.cache, id, cacheIdentifier).then(function (data) {
            step(index, data);
          }).catch(enqueue);
        } else {
          enqueue();
        }
      });
    }
  }]);

  return Uglify;
}();

exports.default = Uglify;